<?php

function decodeSQL($value) {
  $retValue = str_replace("#39;","&#39;",$value);
  $retValue = str_replace("#38;","&amp;",$retValue);
  return($retValue);
}

function encodeSQL($value) {
  $retValue = str_replace("'","#39;",$value);
  $retValue = str_replace("&","#38;",$retValue);
  return($retValue);
}

/**
 * SOURCES:
 */
function getComplianceSources($crId) {
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_SOURCE_VIEW
	          WHERE CR_ID=".$crId."
			      ORDER BY CS_NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllComplianceSources($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM ALL_SOURCES_VIEW ";
  if ($searchFor != "") {
    $query .= "WHERE UPPER(CS_NAME)     LIKE UPPER('%".$searchFor."%')
               OR UPPER(TYPE)           LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_PARENT_NAME) LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_DESCRIPTION) LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_REFERENCE)   LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY CS_NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllRequirementsBySource($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_SOURCE_VIEW ";
  if ($searchFor != "") {
    $query .= "WHERE UPPER(CS_NAME)     LIKE UPPER('%".$searchFor."%')
               OR UPPER(TYPE)           LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_PARENT_NAME) LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_DESCRIPTION) LIKE UPPER('%".$searchFor."%')
               OR UPPER(CS_REFERENCE)   LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY CR_NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}


function addSourceToCR($crId,$sourceId) {
  $db = newDBconn();
  $query = "INSERT INTO C_REQUIREMENT_SOURCE (C_REQUIREMENT, C_SOURCE)
            VALUES ( ".$crId." , ".$sourceId.") ";
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function checkSourceToCR($crId,$sourceId) {
  $db = newDBconn();
  $query = "SELECT COUNT(C_REQUIREMENT)
            FROM C_REQUIREMENT_SOURCE
            WHERE C_REQUIREMENT=".$crId."
            AND C_SOURCE=".$sourceId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  //print_r($records[0][0]);
  return($records[0][0]);
}

function deleteSourceFromCR($crId,$sourceId) {
  $db = newDBconn();
  $query = "DELETE FROM C_REQUIREMENT_SOURCE
            WHERE C_REQUIREMENT = ".$crId."
            AND C_SOURCE = ".$sourceId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function createSource($sName,$sDescription,$sTypeId,$sReference,$sDate,$sMainSourceId) {
  $sName = encodeSQL($sName);
  $sDescription = encodeSQL($sDescription);
  //TODO: sReference & encodeSQL ???
  $db = newDBconn();
  $query = "INSERT INTO COMPLIANCE_SOURCE (NAME, DESCRIPTION,TYPE_ID,REFERENCE, DATE_ISSUED, PARENT_ID)
            VALUES ( '".$sName."' , '".$sDescription."' , ".$sTypeId." ,
                     '".$sReference."', '".$sDate."', ".$sMainSourceId." ) ";
  //echo "<pre>".$query."</pre><br />";
  $result = $db->execute($query);
  $query = "SELECT ID FROM COMPLIANCE_SOURCE
            WHERE NAME='".$sName."' AND
                  DESCRIPTION='".$sDescription."' AND
                  TYPE_ID=".$sTypeId." AND
                  REFERENCE='".$sReference. "' AND
                  PARENT_ID=".$sMainSourceId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0][0]); // Return sourceId
}

function updateSource($sourceId,$sName,$sDescription,$sTypeId,$sReference,$sDate,$sMainSourceId) {
  $sName = encodeSQL($sName);
  $sDescription = encodeSQL($sDescription);
  //TODO: sReference & encodeSQL ???
  $db = newDBconn();
  $query = "UPDATE COMPLIANCE_SOURCE
            SET NAME='".$sName."',
                DESCRIPTION='".$sDescription."' ,
                TYPE_ID=".$sTypeId.",
                REFERENCE='".$sReference."' ,
                DATE_ISSUED='".$sDate."' ,
                PARENT_ID=".$sMainSourceId."
            WHERE ID=".$sourceId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

/**
 * RISKS:
 */
function getComplianceRisks($crId) {
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_RISK_VIEW
	          WHERE REQUIREMENT_ID=".$crId."";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllComplianceRisks($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM ALL_RISKS_VIEW ";
  if ($searchFor != "") {
    $query .= "WHERE UPPER(NAME)            LIKE UPPER('%".$searchFor."%')
               OR UPPER(DESCRIPTION)        LIKE UPPER('%".$searchFor."%')
               OR UPPER(PROB_DESCRIPTION)   LIKE UPPER('%".$searchFor."%')
               OR UPPER(IMPACT_DESCRIPTION) LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllRequirementsByRisk($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_RISK_VIEW ";
  if ($searchFor != "") {
    $query .= "WHERE UPPER(NAME)            LIKE UPPER('%".$searchFor."%')
               OR UPPER(DESCRIPTION)        LIKE UPPER('%".$searchFor."%')
               OR UPPER(PROB_DESCRIPTION)   LIKE UPPER('%".$searchFor."%')
               OR UPPER(IMPACT_DESCRIPTION) LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY CR_NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}


function addRiskToCR($crId,$riskId) {
  $db = newDBconn();
  $query = "INSERT INTO C_REQUIREMENT_RISK (REQUIREMENT_ID, RISK_ID)
            VALUES ( ".$crId." , ".$riskId.") ";
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function checkRiskToCR($crId,$riskId) {
  $db = newDBconn();
  $query = "SELECT COUNT(REQUIREMENT_ID)
            FROM C_REQUIREMENT_RISK
            WHERE REQUIREMENT_ID=".$crId."
            AND RISK_ID=".$riskId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0][0]);
}

function deleteRiskFromCR($crId,$riskId) {
  $db = newDBconn();
  $query = "DELETE FROM C_REQUIREMENT_RISK
            WHERE REQUIREMENT_ID = ".$crId."
            AND RISK_ID = ".$riskId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function createRisk($rName,$rDescription,$pocId,$impactId) {
  $rName = encodeSQL($rName);
  $rDescription = encodeSQL($rDescription);
  $db = newDBconn();
  $query = "INSERT INTO COMPLIANCE_RISK (NAME, DESCRIPTION,PROBABILITY_ID,IMPACT_ID)
            VALUES ( '".$rName."' , '".$rDescription."' , ".$pocId." , ".$impactId." ) ";
  $result = $db->execute($query);
  $query = "SELECT ID FROM COMPLIANCE_RISK
            WHERE NAME='".$rName."' AND
                  DESCRIPTION='".$rDescription."' AND
                  PROBABILITY_ID=".$pocId." AND
                  IMPACT_ID=".$impactId;
  $db->select($query);
  $records = $db->getResult();
//  echo "<pre>";
//  print_r($records);
//  echo "<pre>";
  $db->disconnect();
  return($records[0][0]); // Return RiskId
}

function updateRisk($riskId,$rName,$rDescription,$pocId,$impactId) {
  $rName = encodeSQL($rName);
  $rDescription = encodeSQL($rDescription);
  //TODO: sReference & encodeSQL ???
  $db = newDBconn();
  $query = "UPDATE COMPLIANCE_RISK
            SET NAME='".$rName."',
                DESCRIPTION='".$rDescription."' ,
                PROBABILITY_ID=".$pocId.",
                IMPACT_ID=".$impactId."
            WHERE ID=".$riskId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function deleteRisk($riskId) {
  $db = newDBconn();
  $query = "DELETE FROM COMPLIANCE RISK
            WHERE ID=".$riskId;
  $result = $db->execute($query);
  $query = "DELETE FROM C_REQUIREMENT_RISK
            WHERE RISK_ID=".$riskId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}


/**
 * CONTROLS:
 */
function getControls($crId) {
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_CONTROL_VIEW
	          WHERE REQUIREMENT_ID=".$crId."
            ORDER BY NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllControls($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM ALL_CONTROLS_VIEW ";
  if ($searchFor != "") {
    $query .= " WHERE UPPER(NAME)             LIKE UPPER('%".$searchFor."%')
               OR UPPER(DESCRIPTION)          LIKE UPPER('%".$searchFor."%')
               OR UPPER(PURPOSE_DESCRIPTION)  LIKE UPPER('%".$searchFor."%')
               OR UPPER(CT_NAME)              LIKE UPPER('%".$searchFor."%')
               OR UPPER(CATEGORY_DESCRIPTION) LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getAllReqsByControl($searchFor = "") {
  $searchFor = encodeSQL($searchFor);
  $db = newDBconn();
  $query = "SELECT *
	          FROM C_REQUIREMENT_CONTROL_VIEW ";
  if ($searchFor != "") {
    $query .= " WHERE UPPER(NAME)             LIKE UPPER('%".$searchFor."%')
               OR UPPER(DESCRIPTION)          LIKE UPPER('%".$searchFor."%')
               OR UPPER(PURPOSE_DESCRIPTION)  LIKE UPPER('%".$searchFor."%')
               OR UPPER(CT_NAME)              LIKE UPPER('%".$searchFor."%')
               OR UPPER(CATEGORY_DESCRIPTION) LIKE UPPER('%".$searchFor."%')";
  }
  $query .= " ORDER BY CR_NAME ";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}


function addControlToCR($crId,$controlId) {
  $db = newDBconn();
  $query = "INSERT INTO C_REQUIREMENT_CONTROL (REQUIREMENT_ID, CONTROL_ID)
            VALUES ( ".$crId." , ".$controlId.") ";
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function checkControlToCR($crId,$controlId) {
  $db = newDBconn();
  $query = "SELECT COUNT(REQUIREMENT_ID)
            FROM C_REQUIREMENT_CONTROL
            WHERE REQUIREMENT_ID=".$crId."
            AND CONTROL_ID=".$controlId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0][0]);
}

function deleteControlFromCR($crId,$controlId) {
  $db = newDBconn();
  $query = "DELETE FROM C_REQUIREMENT_CONTROL
            WHERE REQUIREMENT_ID = ".$crId."
            AND CONTROL_ID = ".$controlId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function getControlRules($controlId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM CONTROL_RULES_VIEW
            WHERE CONTROL_ID=".$controlId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getControl($controlId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM ALL_CONTROLS_VIEW
            WHERE CONTROL_ID=".$controlId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0]);
}

function SQLbool($value) {
//TODO: check if $value is boolean/1..0 or something else.
  $retVal = "N";
  if ($value == "true") {
    $retVal = "Y";
  }
  return($retVal);
}

function createControl($Name, $Description, $PurposeId, $CategoryId,
                       $chkCE, $chkRA, $chkCA, $chkIC, $chkMO, $WeightId) {
  $Name = encodeSQL($Name);
  $Description = encodeSQL($Description);
  $db = newDBconn();
  $query = "INSERT INTO CONTROL (NAME, DESCRIPTION, PURPOSE_TYPE_ID, CATEGORY_ID,
                                 CONTROL_ENVIRONMENT, RISK_ASSESSMENT,
                                 CONTROL_ACTIVITIES, INFORMATION_COMMUNICATION, MONITORING, WEIGHT_ID)
            VALUES ( '".$Name."' , '".$Description."', ".$PurposeId." , ".$CategoryId." ,
                     '".SQLbool($chkCE)."' , '".SQLbool($chkRA)."' , '".SQLbool($chkCA)."' ,
                     '".SQLbool($chkIC)."' , '".SQLbool($chkMO)."' , ".$WeightId." ) ";
  $result = $db->execute($query);
  $query = "SELECT ID FROM CONTROL
            WHERE NAME='".$Name."' AND
                  DESCRIPTION='".$Description."' AND
                  PURPOSE_TYPE_ID=".$PurposeId. " AND
                  CATEGORY_ID=".$CategoryId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0][0]);
}

function updateControl($controlId, $Name, $Description, $PurposeId, $CategoryId,
                       $chkCE, $chkRA, $chkCA, $chkIC, $chkMO, $WeightId) {
  $Name = encodeSQL($Name);
  $Description = encodeSQL($Description);
  $db = newDBconn();
  $query = "UPDATE CONTROL
            SET NAME='".$Name."' ,
                DESCRIPTION='".$Description."' ,
                PURPOSE_TYPE_ID=".$PurposeId." ,
                CATEGORY_ID=".$CategoryId." ,
                CONTROL_ENVIRONMENT='".SQLbool($chkCE)."' ,
                RISK_ASSESSMENT='".SQLbool($chkRA)."' ,
                CONTROL_ACTIVITIES='".SQLbool($chkCA)."' ,
                INFORMATION_COMMUNICATION='".SQLbool($chkIC)."' ,
                MONITORING='".SQLbool($chkMO)."' ,
                WEIGHT_ID=".$WeightId."
            WHERE ID=".$controlId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function getTypeRecords($parentId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM TYPES
            WHERE PARENTID=".$parentId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getSource($sourceId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM ALL_SOURCES_VIEW
            WHERE ID=".$sourceId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0]);
}

function getRisk($riskId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM ALL_RISKS_VIEW
            WHERE ID=".$riskId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0]);
}

/**
 * CONTROL TARGETS:
 *
 */
function getAllTargets() {
  $db = newDBconn();
  $query = "SELECT *
            FROM ALL_TARGETS_VIEW
            ORDER BY NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function getTargets($controlId) {
  $db = newDBconn();
  $query = "SELECT *
            FROM C_REQUIREMENT_TARGET_VIEW
            WHERE CONTROL_ID=".$controlId."
            ORDER BY NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function searchAllTargets($search) {
  $search = encodeSQL($search);
  $db = newDBconn();
  $query = "SELECT *
            FROM ALL_TARGETS_VIEW
            WHERE UPPER(NAME) LIKE UPPER('%".$search."%')
            OR UPPER(DESCRIPTION) LIKE UPPER('%".$search."%')
            OR UPPER(TARGET_TYPE) LIKE UPPER('%".$search."%')
            ORDER BY NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

function addControlTarget($controlId,$targetId) {
  $db = newDBconn();
  $query = "INSERT INTO CONTROL_TARGET (CONTROL_ID, TARGET_ID)
            VALUES ( ".$controlId." , ".$targetId.") ";
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function removeControlTarget($controlId,$targetId) {
  $db = newDBconn();
  $query = "DELETE FROM CONTROL_TARGET
            WHERE CONTROL_ID = ".$controlId."
            AND TARGET_ID = ".$targetId;
  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

/**
 * Requirements:
 *
 */
function createRequirement($Name,$Description) {
  $Name = encodeSQL($Name);
  $Description = encodeSQL($Description);
  $db = newDBconn();
  if ($Description== "") {$Description = "..."; }
  $query = "INSERT INTO COMPLIANCE_REQUIREMENT (NAME,DESCRIPTION)
            VALUES ('".$Name."','".$Description."')";
  $db->execute($query);
  $query = "SELECT ID FROM COMPLIANCE_REQUIREMENT
            WHERE NAME='".$Name."' AND
                  DESCRIPTION='".$Description."'";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return ($records[0][0]);
}

function updateRequirement($crId,$Name,$Description) {
  $Name = encodeSQL($Name);
  $Description = encodeSQL($Description);
  $db = newDBconn();
  $query = "UPDATE COMPLIANCE_REQUIREMENT
            SET NAME='".$Name."' ,
                DESCRIPTION='".$Description."'
            WHERE ID=".$crId;

//echo "<pre>".$query."</pre>";

  $result = $db->execute($query);
  $db->disconnect();
  return($result);
}

function getRequirement($crId) {
  $db = newDBconn();
  $query = "SELECT * FROM COMPLIANCE_REQUIREMENT
            WHERE ID=".$crId;
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records[0]);
}

function getAllComplianceRequirements($search) {
  $search = encodeSQL($search);
  $db = newDBconn();
  $query = "SELECT *
            FROM COMPLIANCE_REQUIREMENT
            WHERE UPPER(NAME) LIKE UPPER('%".$search."%')
            OR UPPER(DESCRIPTION) LIKE UPPER('%".$search."%')
            ORDER BY NAME";
  $db->select($query);
  $records = $db->getResult();
  $db->disconnect();
  return($records);
}

?>