<?php
// Pull in the NuSOAP code
require_once('../lib/nusoap.php');

/*
$records = getSoapControls();
  echo "<br /><pre>";
  print_r($records);
  echo "</pre>";
*/

function getSoapControls() {
  // Create the client instance
  $client = new nusoap_client('http://compas-ict.eu/ws/Control');
  // Check for an error
  $err = $client->getError();
  if ($err) {
  	// Display the error
  	echo '<p><b>Constructor error: ' . $err . '</b></p>';
  	// At this point, you know the call that follows will fail
  }
  // Call the SOAP method
  $list = $client->call('list',array());
  $i=0;
  $records = array();
  foreach ($list as $controlId) {
    $param = array();
    $param["uuid"] = $controlId;
    $result = $client->call('retrieve',$param);
//    Check($client,$result);
    $records = addToControlRecords($result,$i,$records);
    $i++;
  }
  return $records;
}


function addToControlRecords($result,$i,$rec) {
  $xml = new SimpleXMLElement($result);
  $rec[$i][0] = $xml['uuid'];
  $rec[$i][1] = $xml['name'];
  $rec[$i][2] = $xml['description'];
  return $rec;
}

/*
function Check($client,$result) {
  // Check for a fault
  if ($client->fault) {
  	echo '<p><b>Fault: ';
  	print_r($result);
  	echo '</b></p>';
  } else {
  	// Check for errors
  	$err = $client->getError();
  	if ($err) {
  		// Display the error
  		echo '<p><b>Error: ' . $err . '</b></p>';
  	} else {
  		// Display the result
      echo "<pre>";
  		print_r(htmlspecialchars($result));
      echo "<br /><br />";
  		print_r(($result));
      echo "<br /><br />";
  		print_r(($nameSpace));
      echo "</pre>";

      $xml = new SimpleXMLElement($result);
      echo "<pre><br />";
      echo "Name             : ";
      echo $xml['name'];
      echo "<br />";
      echo "uuid             : ";
      echo $xml['uuid'];
      echo "<br />";
      echo "Description      : ";
      echo $xml['description'];
      echo "<br />";
      echo "Objective        : ";
      echo $xml['objective'];
      echo "<br />";
      echo "Purpose Type Id  : ";
      echo $xml['purposeTypeID'];
      echo "<br />";
      echo "Category Id      : ";
      echo $xml['categoryID'];
      echo "<br /></pre>";
    }
	}
  // Display the request and response
  echo '<h2>Request</h2>';
  echo '<pre>' . htmlspecialchars($client->request, ENT_QUOTES) . '</pre>';
  echo '<h2>Response</h2>';
  echo '<pre>' . htmlspecialchars($client->response, ENT_QUOTES) . '</pre>';
  // Display the debug messages
  echo '<h2>Debug</h2>';
  echo '<pre>' . htmlspecialchars($client->debug_str, ENT_QUOTES) . '</pre>';
}
*/
?>
