<?php
// Pull in the NuSOAP code
require_once('../lib/nusoap.php');



function getAllSoapSources() {
  // Create the client instance
  $client = new nusoap_client('http://compas-ict.eu/ws/CSource');
  // Check for an error
  $err = $client->getError();
  if ($err) {
  	// Display the error
  	echo '<p><b>Constructor error: ' . $err . '</b></p>';
  	// At this point, you know the call that follows will fail
  }
  // Call the SOAP method
  $list = $client->call('list',array());
  $i=0;
  $records = array();
  foreach ($list as $Id) {
    $param = array();
    $param["uuid"] = $Id;
    $result = $client->call('retrieve',$param);
    $records = addToSourceRecords($result,$i,$records);
    $i++;
  }
  return $records;
}

function addToSourceRecords($result,$i,$rec) {
  $xml = new SimpleXMLElement($result);
  $rec[$i][0] = $xml['uuid'];
  $rec[$i][1] = $xml['name'];
  $rec[$i][2] = $xml['description'];
  return $rec;
}

/*
if ($client->fault) {
	echo '<p><b>Fault: ';
	print_r($result);
	echo '</b></p>';
} else {
	// Check for errors
	$err = $client->getError();
	if ($err) {
		// Display the error
		echo '<p><b>Error: ' . $err . '</b></p>';
	} else {
		// Display the result
    $xml = new SimpleXMLElement($result);
    echo "<pre><br />";
    echo "Name        : ";
    echo $xml['name'];
    echo "<br />";
    echo "uuid        : ";
    echo $xml['uuid'];
    echo "<br />";
    echo "Description : ";
    echo $xml['description'];
    echo "<br />";
    echo "csourceType : ";
    echo $xml['csourceType'];
    echo "<br />";
    echo "Reference   : ";
    echo $xml['reference'];
    echo "<br />";
    echo "Issued On   : ";
    echo $xml['issuedOn'];
    echo "<br /></pre>";
	}
}

*/
?>
