<?php
// Pull in the NuSOAP code
require_once('../lib/nusoap.php');
// Create the client instance
$client = new nusoap_client('http://compas-ict.eu/ws/TechControl');
// Check for an error
$err = $client->getError();
if ($err) {
	// Display the error
	echo '<p><b>Constructor error: ' . $err . '</b></p>';
	// At this point, you know the call that follows will fail
}
// Call the SOAP method
//$result = $client->call('list',array());
$result = $client->call('retrieve',array("uuid" => "05aa9025-3d09-4870-be9c-6f90663873c0"));
// Check for a fault
if ($client->fault) {
	echo '<p><b>Fault: ';
	print_r($result);
	echo '</b></p>';
} else {
	// Check for errors
	$err = $client->getError();
	if ($err) {
		// Display the error
		echo '<p><b>Error: ' . $err . '</b></p>';
	} else {
		// Display the result
    echo "<pre>";
		print_r(htmlspecialchars($result));
    echo "<br /><br />";
		echo (formatXmlString($result));
    echo "<br /><br />";
		print_r(($nameSpace));
    echo "</pre>";
	}
}



// Display the request and response
echo '<h2>Request</h2>';
echo '<pre>' . formatXmlString($client->request) . '</pre>';
echo '<h2>Response</h2>';
echo '<pre>' . formatXmlString($client->response) . '</pre>';
// Display the debug messages
echo '<h2>Debug</h2>';
echo '<pre>' . htmlspecialchars($client->debug_str, ENT_QUOTES) . '</pre>';



function formatXmlString($xml) {

  // add marker linefeeds to aid the pretty-tokeniser (adds a linefeed between all tag-end boundaries)
  $xml = preg_replace('/(>)(<)(\/*)/', "$1\n$2$3", $xml);

  // now indent the tags
  $token      = strtok($xml, "\n");
  $result     = ''; // holds formatted version as it is built
  $pad        = 0; // initial indent
  $matches    = array(); // returns from preg_matches()

  // scan each line and adjust indent based on opening/closing tags
  while ($token !== false) :

    // test for the various tag states

    // 1. open and closing tags on same line - no change
    if (preg_match('/.+<\/\w[^>]*>$/', $token, $matches)) :
      $indent=0;
    // 2. closing tag - outdent now
    elseif (preg_match('/^<\/\w/', $token, $matches)) :
      $pad--;
      $pad--;
    // 3. opening tag - don't pad this one, only subsequent tags
    elseif (preg_match('/^<\w[^>]*[^\/]>.*$/', $token, $matches)) :
      $indent=2;
    // 4. no indentation needed
    else :
      $indent = 0;
    endif;

    // pad the line with the required number of leading spaces
    $line    = str_pad($token, strlen($token)+$pad, '   ', STR_PAD_LEFT);
    $result .= htmlspecialchars($line,ENT_QUOTES) . "\n"; // add to the cumulative result, with linefeed
    $token   = strtok("\n"); // get the next token
    $pad    += $indent; // update the pad size for subsequent lines
  endwhile;

  return $result;
}

phpinfo();
?>
