<?php
// $Id: fetchfrom.plib 392 2005-10-11 17:32:15Z hoppie $
// $URL: https://infix.uvt.nl/its-external/trunk/sources/uvtlib/fetchfrom.plib $

// A few functions to bridge the gap between running with register_globals
// off versus on. These functions should be used somewhere in the first
// stage of a script, to transfer explicitly given $_REQUEST ($_GET, $_POST,
// $_COOKIE) variables to normal PHP globals, ready for further processing.
// This is not unsafe, as unset external variables will result in initialised
// globals (to ""). And since only an explicit list is fetched, the common
// exploit to inject unexpected variables into a script won't work.



function fetchFromREQUEST($nameList) {
  // Add all given names to the global variable pool, and if the
  // corresponding $_REQUEST['name'] entry exists, use that to fill the
  // created global variable. Otherwise, use "" to fill it.
  // <in> nameList = A comma-separated list of variable names.

  // Break up the name list at the commas.
  $nameArray = explode(",",$nameList);
  // For each name, register it as true global variable.
  foreach ($nameArray as $name) {
    // Clean up the string, it may include whitespace.
    $name = trim($name);
    global $$name;
    if (isset($_REQUEST[$name])) {
      $$name = $_REQUEST[$name];
    } else {
      $$name = "";
    }
  }
}// fetchFromREQUEST


function fetchFromGET($nameList) {
  // Add all given names to the global variable pool, and if the
  // corresponding $_GET['name'] entry exists, use that to fill the
  // created global variable. Otherwise, use "" to fill it.
  // <in> nameList = A comma-separated list of variable names.

  // Break up the name list at the commas.
  $nameArray = explode(",",$nameList);
  // For each name, register it as true global variable.
  foreach ($nameArray as $name) {
    // Clean up the string, it may include whitespace.
    $name = trim($name);
    global $$name;
    if (isset($_GET[$name])) {
      $$name = $_GET[$name];
    } else {
      $$name = "";
    }
  }
}// fetchFromGET


function fetchFromPOST($nameList) {
  // Add all given names to the global variable pool, and if the
  // corresponding $_POST['name'] entry exists, use that to fill the
  // created global variable. Otherwise, use "" to fill it.
  // <in> nameList = A comma-separated list of variable names.

  // Break up the name list at the commas.
  $nameArray = explode(",",$nameList);
  // For each name, register it as true global variable.
  foreach ($nameArray as $name) {
    // Clean up the string, it may include whitespace.
    $name = trim($name);
    global $$name;
    if (isset($_POST[$name])) {
      $$name = $_POST[$name];
    } else {
      $$name = "";
    }
  }
}// fetchFromPOST


function fetchFromCOOKIE($nameList) {
  // Add all given names to the global variable pool, and if the
  // corresponding $_COOKIE['name'] entry exists, use that to fill the
  // created global variable. Otherwise, use "" to fill it.
  // <in> nameList = A comma-separated list of variable names.

  // Break up the name list at the commas.
  $nameArray = explode(",",$nameList);
  // For each name, register it as true global variable.
  foreach ($nameArray as $name) {
    // Clean up the string, it may include whitespace.
    $name = trim($name);
    global $$name;
    if (isset($_COOKIE[$name])) {
      $$name = $_COOKIE[$name];
    } else {
      $$name = "";
    }
  }
}// fetchFromCOOKIE


function fetchFromFILES($userfile) {
  // <in> userfile = The file upload name as mentioned in the upload script.
  // <out> Array with five elements: name, type, size, tmp_name, and error.
  //       To be able to use list() on this array, the indexes are 0..4.
  //       See the PHP file upload documentation for more info:
  //       http://www.php.net/manual/en/features.file-upload.php

  $output = array('', '', 0, '', 0);

  if (isset($_FILES[$userfile])) {
    $file = $_FILES[$userfile];
    $output[0] = $file['name'];
    $output[1] = $file['type'];
    $output[2] = $file['size'];
    $output[3] = $file['tmp_name'];
    $output[4] = $file['error'];
  }
  return $output;

}// fetchFromFILES

?>
